Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Tools/ScribbleTool.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Tools/ScribbleTool.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Tools/ScribbleTool.cs	(revision 4068)
@@ -1,164 +1,141 @@
 using System;
-using System.Diagnostics;
-using System.Collections;
-using System.Collections.Generic;
 using System.Drawing;
 using System.Windows.Forms;
 
-namespace Netron.Diagramming.Core
-{
+namespace Netron.Diagramming.Core {
 
-    class ScribbleTool : AbstractTool, IMouseListener, IKeyboardListener
-    {
+  class ScribbleTool : AbstractTool, IMouseListener, IKeyboardListener {
 
-        #region Fields
-        /// <summary>
-        /// the location of the mouse when the motion starts
-        /// </summary>
+    #region Fields
+    /// <summary>
+    /// the location of the mouse when the motion starts
+    /// </summary>
 
-        private bool doDraw;
-        private Point[] points;
-        #endregion
-        #region Constructor
-        /// <summary>
-        /// Initializes a new instance of the <see cref="T:ScribbleTool"/> class.
-        /// </summary>
-        /// <param name="name">The name of the tool.</param>
-        public ScribbleTool(string name)
-            : base(name)
-        {
+    private bool doDraw;
+    private Point[] points;
+    #endregion
+    #region Constructor
+    /// <summary>
+    /// Initializes a new instance of the <see cref="T:ScribbleTool"/> class.
+    /// </summary>
+    /// <param name="name">The name of the tool.</param>
+    public ScribbleTool(string name)
+      : base(name) {
+    }
+    #endregion
+
+    #region Methods
+
+    /// <summary>
+    /// Called when the tool is activated.
+    /// </summary>
+    protected override void OnActivateTool() {
+      Controller.View.CurrentCursor = CursorPalette.Cross;
+      this.SuspendOtherTools();
+      doDraw = false;
+      points = new Point[1];
+    }
+
+    /// <summary>
+    /// Handles the mouse down event
+    /// </summary>
+    /// <param name="e">The <see cref="T:System.Windows.Forms.MouseEventArgs"/> instance containing the event data.</param>
+    /// <returns>Returns 'true' if the event was handled, otherwise 'false'.</returns>
+    public bool MouseDown(MouseEventArgs e) {
+      if (e == null)
+        throw new ArgumentNullException("The argument object is 'null'");
+      if (e.Button == MouseButtons.Left && Enabled && !IsSuspended) {
+        Point p = e.Location;
+        if (Closure(p)) {
+          points[points.Length - 1] = points[0];
+          doDraw = false;
+          DeactivateTool();
+          Package();
+
+          return true;
         }
-        #endregion
+        Array.Resize<Point>(ref points, points.Length + 1);
+        points[points.Length - 2] = e.Location;
+        doDraw = true;
+        return true;
+      }
+      return false;
+    }
 
-        #region Methods
+    /// <summary>
+    /// Handles the mouse move event
+    /// </summary>
+    /// <param name="e">The <see cref="T:System.Windows.Forms.MouseEventArgs"/> instance containing the event data.</param>
+    public void MouseMove(MouseEventArgs e) {
+      if (e == null)
+        throw new ArgumentNullException("The argument object is 'null'");
+      Point point = e.Location;
+      if (IsActive && doDraw) {
+        points[points.Length - 1] = e.Location;
+        Controller.View.PaintGhostLine(MultiPointType.Curve, points);
+        //Controller.View.Invalidate(System.Drawing.Rectangle.Inflate(Controller.View.Ghost.Rectangle, 20, 20));
+        //TODO: find a more performant way to invalidate the area
+        Controller.View.Invalidate();
+      }
+    }
+    private bool Closure(Point p) {
+      for (int k = 0; k < points.Length - 1; k++) {
+        if (new Rectangle(points[k].X - 6, points[k].Y - 6, 12, 12).Contains(p)) {
+          DialogResult res = MessageBox.Show("Do you wish to close the curve?", "Closure?", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
+          if (res == DialogResult.Yes)
+            return true;
 
-        /// <summary>
-        /// Called when the tool is activated.
-        /// </summary>
-        protected override void OnActivateTool()
-        {
-            Controller.View.CurrentCursor = CursorPalette.Cross;
-            this.SuspendOtherTools();
-            doDraw = false;
-            points = new Point[1];
         }
+      }
+      return false;
+    }
+    /// <summary>
+    /// 
+    /// </summary>
+    /// <param name="e">The <see cref="T:System.Windows.Forms.MouseEventArgs"/> instance containing the event data.</param>
+    public void MouseUp(MouseEventArgs e) {
+      if (IsActive) {
 
-        /// <summary>
-        /// Handles the mouse down event
-        /// </summary>
-        /// <param name="e">The <see cref="T:System.Windows.Forms.MouseEventArgs"/> instance containing the event data.</param>
-        /// <returns>Returns 'true' if the event was handled, otherwise 'false'.</returns>
-        public bool MouseDown(MouseEventArgs e)
-        {
-            if (e == null)
-                throw new ArgumentNullException("The argument object is 'null'");
-            if (e.Button == MouseButtons.Left && Enabled && !IsSuspended)
-            {
-                Point p = e.Location;
-                if (Closure(p))
-                {
-                    points[points.Length - 1] = points[0];
-                    doDraw = false;
-                    DeactivateTool();
-                    Package();
+      }
+    }
+    private void Package() {
+      if ((points == null) ||
+         (points.Length < 1) ||
+         (points[0] == Point.Empty)) {
+        return;
+      }
 
-                    return true;
-                }
-                Array.Resize<Point>(ref points, points.Length + 1);
-                points[points.Length - 2] = e.Location;
-                doDraw = true;
-                return true;
-            }
-            return false;
-        }
+      MultiPointShape shape = new MultiPointShape(
+          this.Controller.Model,
+          points,
+          MultiPointType.Curve);
 
-        /// <summary>
-        /// Handles the mouse move event
-        /// </summary>
-        /// <param name="e">The <see cref="T:System.Windows.Forms.MouseEventArgs"/> instance containing the event data.</param>
-        public void MouseMove(MouseEventArgs e)
-        {
-            if (e == null)
-                throw new ArgumentNullException("The argument object is 'null'");
-            Point point = e.Location;
-            if (IsActive && doDraw)
-            {
-                points[points.Length - 1] = e.Location;
-                Controller.View.PaintGhostLine(MultiPointType.Curve, points);
-                //Controller.View.Invalidate(System.Drawing.Rectangle.Inflate(Controller.View.Ghost.Rectangle, 20, 20));
-                //TODO: find a more performant way to invalidate the area
-                Controller.View.Invalidate();
-            }
-        }
-        private bool Closure(Point p)
-        {
-            for (int k = 0; k < points.Length - 1; k++)
-            {
-                if (new Rectangle(points[k].X - 6, points[k].Y - 6, 12, 12).Contains(p))
-                {
-                    DialogResult res = MessageBox.Show("Do you wish to close the curve?", "Closure?", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
-                    if (res == DialogResult.Yes)
-                        return true;
+      AddMultiPointShapeCommand cmd = new AddMultiPointShapeCommand(this.Controller, shape);
+      this.Controller.UndoManager.AddUndoCommand(cmd);
+      this.Controller.View.ResetGhost();
+      cmd.Redo();
+    }
+    #endregion
 
-                }
-            }
-            return false;
-        }
-        /// <summary>
-        /// 
-        /// </summary>
-        /// <param name="e">The <see cref="T:System.Windows.Forms.MouseEventArgs"/> instance containing the event data.</param>
-        public void MouseUp(MouseEventArgs e)
-        {
-            if (IsActive)
-            {
+    #region IKeyboardListener Members
 
-            }
-        }
-        private void Package()
-        {
-            if ((points == null) ||
-               (points.Length < 1) ||
-               (points[0] == Point.Empty) )
-            {
-                return;
-            }
-
-            MultiPointShape shape = new MultiPointShape(
-                this.Controller.Model, 
-                points, 
-                MultiPointType.Curve);
-
-            AddMultiPointShapeCommand cmd = new AddMultiPointShapeCommand(this.Controller, shape);
-            this.Controller.UndoManager.AddUndoCommand(cmd);
-            this.Controller.View.ResetGhost();
-            cmd.Redo();
-        }
-        #endregion
-
-        #region IKeyboardListener Members
-
-        public void KeyDown(KeyEventArgs e)
-        {
+    public void KeyDown(KeyEventArgs e) {
 
 
-            if (e.KeyData == System.Windows.Forms.Keys.Escape && IsActive)
-            {
-                DeactivateTool();
-                Package();
-                e.Handled = true;
-            }
-        }
-
-        public void KeyUp(KeyEventArgs e)
-        {
-        }
-
-        public void KeyPress(KeyPressEventArgs e)
-        {
-        }
-
-        #endregion
+      if (e.KeyData == System.Windows.Forms.Keys.Escape && IsActive) {
+        DeactivateTool();
+        Package();
+        e.Handled = true;
+      }
     }
 
+    public void KeyUp(KeyEventArgs e) {
+    }
+
+    public void KeyPress(KeyPressEventArgs e) {
+    }
+
+    #endregion
+  }
+
 }
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Tools/SelectionTool.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Tools/SelectionTool.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Tools/SelectionTool.cs	(revision 4068)
@@ -1,140 +1,127 @@
 using System;
-using System.Diagnostics;
-using System.Collections;
 using System.Drawing;
 using System.Windows.Forms;
 
-namespace Netron.Diagramming.Core
-{
-    // ----------------------------------------------------------------------
+namespace Netron.Diagramming.Core {
+  // ----------------------------------------------------------------------
+  /// <summary>
+  /// This tool implements the standard rectangular selection mechanism. 
+  /// There are two modes (much like Visio).
+  /// <list type="bullet">
+  /// <item><term>Inclusive</term><description>elements are selected if 
+  /// they are contained in the selection rectangle</description></item>
+  /// <item><term>Touching</term><description>elements are selected if the 
+  /// selection rectangle has an overlap with the element</description>
+  /// </item>
+  /// </list>
+  /// <para>Note that this tool is slightly different than other tools 
+  /// since it activates itself unless it has been suspended by another 
+  /// tool. </para>
+  /// </summary>
+  // ----------------------------------------------------------------------
+  public class SelectionTool : AbstractTool, IMouseListener {
+    #region Fields
+
+    // ------------------------------------------------------------------
     /// <summary>
-    /// This tool implements the standard rectangular selection mechanism. 
-    /// There are two modes (much like Visio).
-    /// <list type="bullet">
-    /// <item><term>Inclusive</term><description>elements are selected if 
-    /// they are contained in the selection rectangle</description></item>
-    /// <item><term>Touching</term><description>elements are selected if the 
-    /// selection rectangle has an overlap with the element</description>
-    /// </item>
-    /// </list>
-    /// <para>Note that this tool is slightly different than other tools 
-    /// since it activates itself unless it has been suspended by another 
-    /// tool. </para>
+    /// The location of the mouse when the motion starts.
     /// </summary>
-    // ----------------------------------------------------------------------
-    public class SelectionTool : AbstractTool, IMouseListener
-    {
-        #region Fields
+    // ------------------------------------------------------------------
+    private Point initialPoint;
 
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// The location of the mouse when the motion starts.
-        /// </summary>
-        // ------------------------------------------------------------------
-        private Point initialPoint;
+    #endregion
 
-        #endregion
+    #region Constructor
+    /// <summary>
+    /// Initializes a new instance of the <see cref="T:SelectionTool"/> class.
+    /// </summary>
+    /// <param name="name">The name of the tool.</param>
+    public SelectionTool(string name)
+      : base(name) {
+    }
+    #endregion
 
-        #region Constructor
-        /// <summary>
-        /// Initializes a new instance of the <see cref="T:SelectionTool"/> class.
-        /// </summary>
-        /// <param name="name">The name of the tool.</param>
-        public SelectionTool(string name) : base(name)
-        {
-        }
-        #endregion
+    #region Methods
 
-        #region Methods
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Called when the tool is activated.
-        /// </summary>
-        // ------------------------------------------------------------------
-        protected override void OnActivateTool()
-        {
-            Controller.View.CurrentCursor = CursorPalette.Selection;
-        }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Handles the mouse down event.
-        /// </summary>
-        /// <param name="e">The 
-        /// <see cref="T:System.Windows.Forms.MouseEventArgs"/> instance 
-        /// containing the event data.</param>
-        // ------------------------------------------------------------------
-        public bool MouseDown(MouseEventArgs e)
-        {
-            if (e == null)
-                throw new ArgumentNullException(
-                    "The argument object is 'null'");
-
-            if (e.Button == MouseButtons.Left && Enabled && !IsSuspended)
-            {
-              if (this.Controller.Model.Selection.SelectedItems.Count == 0 && this.Controller.Model.Selection.Connector == null)
-                {
-                    initialPoint = e.Location;
-                    ActivateTool();
-                    return true;// This tells the tool-loop to stop looking 
-                    // for another handler, which keeps the CPU low.
-                }                
-            }
-            return false;
-        }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Handles the mouse move event.
-        /// </summary>
-        /// <param name="e">The 
-        /// <see cref="T:System.Windows.Forms.MouseEventArgs"/> instance 
-        /// containing the event data.</param>
-        // ------------------------------------------------------------------
-        public void MouseMove(MouseEventArgs e)
-        {
-            if (e == null)
-                throw new ArgumentNullException(
-                    "The argument object is 'null'");
-            IView view = this.Controller.View;
-            Point point = e.Location;
-            if(IsActive && !IsSuspended)
-            {
-                Controller.View.PaintGhostRectangle(initialPoint, point);
-                Rectangle rec = System.Drawing.Rectangle.Inflate(
-                    Controller.View.Ghost.Rectangle, 20, 20);
-                
-                Controller.View.Invalidate(rec);
-            }            
-        }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Handles the mouse up event.
-        /// </summary>
-        /// <param name="e">The 
-        /// <see cref="T:System.Windows.Forms.MouseEventArgs"/> instance 
-        /// containing the event data.</param>
-        // ------------------------------------------------------------------
-        public void MouseUp(MouseEventArgs e)
-        {
-            if (IsActive)
-            {
-                DeactivateTool();
-                if(Controller.View.Ghost != null)
-                {
-                   this.Controller.Model.Selection.CollectEntitiesInside(
-                        Controller.View.Ghost.Rectangle);//world space
-
-                    Controller.RaiseOnShowSelectionProperties(
-                        new SelectionEventArgs(
-                       this.Controller.Model.Selection.SelectedItems.ToArray()));
-                }
-                Controller.View.ResetGhost();                
-            }
-        }
-        #endregion
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Called when the tool is activated.
+    /// </summary>
+    // ------------------------------------------------------------------
+    protected override void OnActivateTool() {
+      Controller.View.CurrentCursor = CursorPalette.Selection;
     }
 
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Handles the mouse down event.
+    /// </summary>
+    /// <param name="e">The 
+    /// <see cref="T:System.Windows.Forms.MouseEventArgs"/> instance 
+    /// containing the event data.</param>
+    // ------------------------------------------------------------------
+    public bool MouseDown(MouseEventArgs e) {
+      if (e == null)
+        throw new ArgumentNullException(
+            "The argument object is 'null'");
+
+      if (e.Button == MouseButtons.Left && Enabled && !IsSuspended) {
+        if (this.Controller.Model.Selection.SelectedItems.Count == 0 && this.Controller.Model.Selection.Connector == null) {
+          initialPoint = e.Location;
+          ActivateTool();
+          return true;// This tells the tool-loop to stop looking 
+          // for another handler, which keeps the CPU low.
+        }
+      }
+      return false;
+    }
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Handles the mouse move event.
+    /// </summary>
+    /// <param name="e">The 
+    /// <see cref="T:System.Windows.Forms.MouseEventArgs"/> instance 
+    /// containing the event data.</param>
+    // ------------------------------------------------------------------
+    public void MouseMove(MouseEventArgs e) {
+      if (e == null)
+        throw new ArgumentNullException(
+            "The argument object is 'null'");
+      IView view = this.Controller.View;
+      Point point = e.Location;
+      if (IsActive && !IsSuspended) {
+        Controller.View.PaintGhostRectangle(initialPoint, point);
+        Rectangle rec = System.Drawing.Rectangle.Inflate(
+            Controller.View.Ghost.Rectangle, 20, 20);
+
+        Controller.View.Invalidate(rec);
+      }
+    }
+
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Handles the mouse up event.
+    /// </summary>
+    /// <param name="e">The 
+    /// <see cref="T:System.Windows.Forms.MouseEventArgs"/> instance 
+    /// containing the event data.</param>
+    // ------------------------------------------------------------------
+    public void MouseUp(MouseEventArgs e) {
+      if (IsActive) {
+        DeactivateTool();
+        if (Controller.View.Ghost != null) {
+          this.Controller.Model.Selection.CollectEntitiesInside(
+               Controller.View.Ghost.Rectangle);//world space
+
+          Controller.RaiseOnShowSelectionProperties(
+              new SelectionEventArgs(
+             this.Controller.Model.Selection.SelectedItems.ToArray()));
+        }
+        Controller.View.ResetGhost();
+      }
+    }
+    #endregion
+  }
+
 }
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Tools/SendBackwardsTool.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Tools/SendBackwardsTool.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Tools/SendBackwardsTool.cs	(revision 4068)
@@ -1,112 +1,98 @@
 using System;
+using System.Collections;
+using System.Collections.Generic;
 using System.Diagnostics;
-using System.Collections;
-using System.Drawing;
-using System.Windows.Forms;
-using System.Collections.Generic;
-namespace Netron.Diagramming.Core
-{
+namespace Netron.Diagramming.Core {
+  /// <summary>
+  /// Group tool
+  /// </summary>
+  class SendBackwardsTool : AbstractTool {
+
+    #region Fields
+
+    #endregion
+
+    #region Constructor
     /// <summary>
-    /// Group tool
+    /// Initializes a new instance of the <see cref="T:SendBackwards"/> class.
     /// </summary>
-    class SendBackwardsTool : AbstractTool
-    {
+    /// <param name="name">The name of the tool.</param>
+    public SendBackwardsTool(string name)
+      : base(name) {
+    }
+    #endregion
 
-        #region Fields
-     
-        #endregion
+    #region Methods
 
-        #region Constructor
-        /// <summary>
-        /// Initializes a new instance of the <see cref="T:SendBackwards"/> class.
-        /// </summary>
-        /// <param name="name">The name of the tool.</param>
-        public SendBackwardsTool(string name)
-            : base(name)
-        {
+    /// <summary>
+    /// Called when the tool is activated.
+    /// </summary>
+    protected override void OnActivateTool() {
+      if (this.Controller.Model.Selection.SelectedItems != null && this.Controller.Model.Selection.SelectedItems.Count > 0) {
+        /*
+       * They should give me a Nobel prize for so much thinking early in the morning...
+       */
+        #region Preparation of the ordering
+        Debug.Assert(this.Controller.Model.Selection.SelectedItems[0] != null, "A selection cannot contain a 'null' entity.");
+        //the items have to be moved in the order of the Paintables; the SortedList automatically orders things for us.
+        SortedList<int, IDiagramEntity> list = new SortedList<int, IDiagramEntity>();
+        //We fetch a flattened selection, which means that if there is a group the constituents will be
+        //returned rather than the group itself.
+        foreach (IDiagramEntity entity in this.Controller.Model.Selection.FlattenedSelectionItems) {
+          //the addition will automatically put the item in increasing order
+          list.Add(this.Controller.Model.Paintables.IndexOf(entity), entity);
+        }
+        //if the lowest z-value is the first one in the paintables we cannot shift anything, so we quit
+        if (list.Keys[0] == 0) return;
+
+        /*Send them forwards but make sure it's a visible effect!
+        It's not enough to move it only once since the shape(s) above might be of
+        high z-order degree, so we have to find which is the first shape overlapping with 
+        the selection and take as many steps as it takes to surpass it.
+         If there is no overlap we'll shift the z-order with just one unit.
+        */
+        int delta = 1;
+        int lowestZInSelection = list.Keys[0];
+        bool found = false;
+        //we can speed up the loop by noticing that the previous shape in the z-stack is necessarily
+        //below the first one of the selection
+        for (int m = lowestZInSelection - 1; m >= 0 && !found; m--) {
+          //the overlap has to be with an entity, not from the selection
+          if (list.ContainsValue(this.Controller.Model.Paintables[m])) continue;
+          for (int s = 0; s < list.Count; s++) {
+            //if there is an overlap we found the required index
+            if (this.Controller.Model.Paintables[m].Rectangle.IntersectsWith(list.Values[s].Rectangle)) {
+              //an additional complication here; if the found shape is part of a group we have
+              //to take the upper z-value of the group...
+              if (this.Controller.Model.Paintables[m].Group != null) {
+                int min = int.MaxValue;
+                CollectionBase<IDiagramEntity> leafs = new CollectionBase<IDiagramEntity>();
+                Utils.TraverseCollect(this.Controller.Model.Paintables[m].Group, ref leafs);
+                foreach (IDiagramEntity groupMember in leafs) {
+                  min = Math.Min(min, this.Controller.Model.Paintables.IndexOf(groupMember));
+                }
+                //take the found z-value of the group rather than the one of the group-child
+                m = min;
+              }
+              delta = lowestZInSelection - m;
+              found = true;
+              break;
+            }
+
+          }
         }
         #endregion
+        Debug.Assert(delta >= 1, "The shift cannot be less than one since we checked previous situations earlier.");
+        for (int k = 0; k < list.Count; k++) {
+          this.Controller.Model.SendBackwards(list.Values[k], delta);
+        }
+      }
+      DeactivateTool();
+    }
 
-        #region Methods
-
-        /// <summary>
-        /// Called when the tool is activated.
-        /// </summary>
-        protected override void OnActivateTool()
-        {
-          if (this.Controller.Model.Selection.SelectedItems != null && this.Controller.Model.Selection.SelectedItems.Count > 0)
-            {
-                /*
-               * They should give me a Nobel prize for so much thinking early in the morning...
-               */
-                #region Preparation of the ordering
-              Debug.Assert(this.Controller.Model.Selection.SelectedItems[0] != null, "A selection cannot contain a 'null' entity.");
-                //the items have to be moved in the order of the Paintables; the SortedList automatically orders things for us.
-                SortedList<int, IDiagramEntity> list = new SortedList<int, IDiagramEntity>();
-                //We fetch a flattened selection, which means that if there is a group the constituents will be
-                //returned rather than the group itself.
-                foreach (IDiagramEntity entity in this.Controller.Model.Selection.FlattenedSelectionItems)
-                {
-                    //the addition will automatically put the item in increasing order
-                    list.Add(this.Controller.Model.Paintables.IndexOf(entity), entity);
-                }
-                //if the lowest z-value is the first one in the paintables we cannot shift anything, so we quit
-                if (list.Keys[0] == 0) return;
-
-                /*Send them forwards but make sure it's a visible effect!
-                It's not enough to move it only once since the shape(s) above might be of
-                high z-order degree, so we have to find which is the first shape overlapping with 
-                the selection and take as many steps as it takes to surpass it.
-                 If there is no overlap we'll shift the z-order with just one unit.
-                */
-                int delta = 1;
-                int lowestZInSelection = list.Keys[0];
-                bool found = false;
-                //we can speed up the loop by noticing that the previous shape in the z-stack is necessarily
-                //below the first one of the selection
-                for (int m = lowestZInSelection-1; m>=0 && !found; m--)
-                {
-                    //the overlap has to be with an entity, not from the selection
-                    if (list.ContainsValue(this.Controller.Model.Paintables[m])) continue;
-                    for (int s = 0; s < list.Count; s++)
-                    {
-                        //if there is an overlap we found the required index
-                        if (this.Controller.Model.Paintables[m].Rectangle.IntersectsWith(list.Values[s].Rectangle))
-                        {
-                            //an additional complication here; if the found shape is part of a group we have
-                            //to take the upper z-value of the group...
-                            if (this.Controller.Model.Paintables[m].Group != null)
-                            {
-                                int min = int.MaxValue;
-                                CollectionBase<IDiagramEntity> leafs = new CollectionBase<IDiagramEntity>();
-                                Utils.TraverseCollect(this.Controller.Model.Paintables[m].Group, ref leafs);
-                                foreach (IDiagramEntity groupMember in leafs)
-                                {
-                                    min = Math.Min(min, this.Controller.Model.Paintables.IndexOf(groupMember));
-                                }
-                                //take the found z-value of the group rather than the one of the group-child
-                                m = min;
-                            }
-                            delta = lowestZInSelection - m ;
-                            found = true;
-                            break;
-                        }
-
-                    }
-                }
-                #endregion
-                Debug.Assert(delta >= 1, "The shift cannot be less than one since we checked previous situations earlier.");
-                for (int k = 0; k < list.Count; k++)
-                {
-                    this.Controller.Model.SendBackwards(list.Values[k], delta);
-                }
-            }
-            DeactivateTool();
-        }
-        
-        #endregion
+    #endregion
 
 
-    }
+  }
 
 }
